import binascii


class GIF:
    extension = 'gif'

    def __init__(self):
        pass

    # 检测文件格式，返回百分比
    @staticmethod
    def test(data: bytearray):
        return 100
    
    # 获取图片信息
    @staticmethod
    def get_info(data: bytearray):
        info = {}
        return info
    
    def check_tail(data: bytearray):
        changed = False
        tail = None
        return changed, data, tail
    
    # 修复文件头
    @staticmethod
    def repair_sig(data: bytearray):
        changed = False
        head = None
        print('[*] 检测文件头')
        sig = b'\x89\x50\x4E\x47\x0D\x0A\x1A\x0A'
        index = data.find(sig)
        if index != -1:
            print('[x] 检测到文件头前有垃圾数据，已尝试修复')
            head = data[:index]
            data = data[index:]
            changed = True
        elif data[0:8] != sig:
            print('[x] 检测到文件头异常，已尝试修复')
            data[0:8] = sig
            changed = True
        return changed, data, head
    
    # 修复尺寸
    @staticmethod
    def repair_size(data: bytearray):
        changed = False
        print('[*] 检测文件尺寸')
        chunk_begin = 8
        width_begin = chunk_begin + 8
        height_begin = chunk_begin + 12
        length = int.from_bytes(data[chunk_begin:chunk_begin+4], byteorder='big')
        chunk_data = data[chunk_begin+4: chunk_begin+4+length]
        ctype = chunk_data[0:4] # 应该为 b'\x49\x48\x44\x52'，即 b'IHDR'
        width = int.from_bytes(chunk_data[4:8], byteorder='big')
        height = int.from_bytes(chunk_data[8:12], byteorder='big')
        crc = chunk_data[-4:]

        if GIF.test_ihdr_chunk(chunk_data[:-4], crc):
            print(' - 图片尺寸设置正确')
        else:
            if width == 0:
                print('[x] 检测到图片宽度设置异常，尝试修复...')
                for i in range(1, 2048):
                    chunk_data[4:8] = i.to_bytes(4, byteorder='big')
                    if GIF.test_ihdr_chunk(chunk_data[:-4], crc):
                        width = i
                        print(f'[*] 图片宽度修复成功，宽度值为{i}')
                        data[width_begin: width_begin+4] = width.to_bytes(4, byteorder='big')
                        changed = True
                        break
            if width == 0:
                print('[x] 图片宽度修复失败')
            
            temp = input(f'当前宽度值为{width}，高度值为{height}，是否尝试将高度值设置为更高？可输入高度值或直接回车：')
            if temp.isdigit():
                height = int(temp)
                data[height_begin: height_begin+4] = height.to_bytes(4, byteorder='big')
                print(f'[*] 已将图片高度设置为{height}')
                changed = True
        return changed, data
    
    @staticmethod
    def test_ihdr_chunk(chunk_data, crc):
        crc32 = binascii.crc32(chunk_data) & 0xffffffff
        return crc32 == crc
    
    @staticmethod
    def check_data(data: bytearray):
        return False, data, []

